# This file was auto-generated by Fern from our API Definition.

from ...core.client_wrapper import AsyncClientWrapper, SyncClientWrapper
from .raw_client import AsyncRawEligibilityClient, RawEligibilityClient
from .resources.v_2.client import AsyncV2Client, V2Client


class EligibilityClient:
    def __init__(self, *, client_wrapper: SyncClientWrapper):
        self._raw_client = RawEligibilityClient(client_wrapper=client_wrapper)
        self.v_2 = V2Client(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> RawEligibilityClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        RawEligibilityClient
        """
        return self._raw_client


class AsyncEligibilityClient:
    def __init__(self, *, client_wrapper: AsyncClientWrapper):
        self._raw_client = AsyncRawEligibilityClient(client_wrapper=client_wrapper)
        self.v_2 = AsyncV2Client(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> AsyncRawEligibilityClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        AsyncRawEligibilityClient
        """
        return self._raw_client
