# This file was auto-generated by Fern from our API Definition.

from ...core.client_wrapper import AsyncClientWrapper, SyncClientWrapper
from .raw_client import AsyncRawPatientPaymentsClient, RawPatientPaymentsClient
from .resources.v_4.client import AsyncV4Client, V4Client


class PatientPaymentsClient:
    def __init__(self, *, client_wrapper: SyncClientWrapper):
        self._raw_client = RawPatientPaymentsClient(client_wrapper=client_wrapper)
        self.v_4 = V4Client(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> RawPatientPaymentsClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        RawPatientPaymentsClient
        """
        return self._raw_client


class AsyncPatientPaymentsClient:
    def __init__(self, *, client_wrapper: AsyncClientWrapper):
        self._raw_client = AsyncRawPatientPaymentsClient(client_wrapper=client_wrapper)
        self.v_4 = AsyncV4Client(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> AsyncRawPatientPaymentsClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        AsyncRawPatientPaymentsClient
        """
        return self._raw_client
