# This file was auto-generated by Fern from our API Definition.

from .....core.client_wrapper import AsyncClientWrapper, SyncClientWrapper
from .raw_client import AsyncRawCoveragesClient, RawCoveragesClient
from .resources.v_1.client import AsyncV1Client, V1Client


class CoveragesClient:
    def __init__(self, *, client_wrapper: SyncClientWrapper):
        self._raw_client = RawCoveragesClient(client_wrapper=client_wrapper)
        self.v_1 = V1Client(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> RawCoveragesClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        RawCoveragesClient
        """
        return self._raw_client


class AsyncCoveragesClient:
    def __init__(self, *, client_wrapper: AsyncClientWrapper):
        self._raw_client = AsyncRawCoveragesClient(client_wrapper=client_wrapper)
        self.v_1 = AsyncV1Client(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> AsyncRawCoveragesClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        AsyncRawCoveragesClient
        """
        return self._raw_client
