# This file was auto-generated by Fern from our API Definition.

from .....core.client_wrapper import AsyncClientWrapper, SyncClientWrapper
from .raw_client import AsyncRawListsClient, RawListsClient
from .resources.v_1.client import AsyncV1Client, V1Client


class ListsClient:
    def __init__(self, *, client_wrapper: SyncClientWrapper):
        self._raw_client = RawListsClient(client_wrapper=client_wrapper)
        self.v_1 = V1Client(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> RawListsClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        RawListsClient
        """
        return self._raw_client


class AsyncListsClient:
    def __init__(self, *, client_wrapper: AsyncClientWrapper):
        self._raw_client = AsyncRawListsClient(client_wrapper=client_wrapper)
        self.v_1 = AsyncV1Client(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> AsyncRawListsClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        AsyncRawListsClient
        """
        return self._raw_client
