# This file was auto-generated by Fern from our API Definition.

from ...core.client_wrapper import AsyncClientWrapper, SyncClientWrapper
from .raw_client import AsyncRawWriteOffsClient, RawWriteOffsClient
from .resources.v_1.client import AsyncV1Client, V1Client


class WriteOffsClient:
    def __init__(self, *, client_wrapper: SyncClientWrapper):
        self._raw_client = RawWriteOffsClient(client_wrapper=client_wrapper)
        self.v_1 = V1Client(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> RawWriteOffsClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        RawWriteOffsClient
        """
        return self._raw_client


class AsyncWriteOffsClient:
    def __init__(self, *, client_wrapper: AsyncClientWrapper):
        self._raw_client = AsyncRawWriteOffsClient(client_wrapper=client_wrapper)
        self.v_1 = AsyncV1Client(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> AsyncRawWriteOffsClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        AsyncRawWriteOffsClient
        """
        return self._raw_client
